#C:> activate keras
#(keras) C:> set TF_CPP_MIN_LOG_LEVEL=2
#(keras) C:> python
# >>>

import numpy as np
import cv2
from keras.layers import Input
from keras.layers.convolutional import Conv2D
from keras.models import Model

inp = Input(shape=(None,None,1))
out = Conv2D(1, (3, 3), kernel_initializer='normal', use_bias=False, padding='same')(inp)
model = Model(inputs=inp, outputs=out)

len(model.layers)
model.layers[0].get_weights()
model.layers[1].get_weights()

w = np.array([[
	[[[-1]],[[0]],[[1]]],
	[[[-2]],[[0]],[[2]]],
	[[[-1]],[[0]],[[1]]]
	]])
model.layers[1].set_weights(w)
model.layers[1].get_weights()
	
input_images = np.array([[
    [[1],[1],[1],[1],[1]],
    [[1],[1],[1],[1],[1]],
    [[1],[1],[1],[1],[1]],
    [[1],[1],[1],[1],[1]],
    [[1],[1],[1],[1],[1]]
    ]])
output_images = model.predict(input_images)
output_images[0]

input_images = np.array([[
    [[1],[1],[0],[0],[0]],
    [[1],[1],[0],[0],[0]],
    [[1],[1],[0],[0],[0]],
    [[1],[1],[0],[0],[0]],
    [[1],[1],[0],[0],[0]]
    ]])
output_images = model.predict(input_images)
output_images[0]

image = cv2.imread('lena.jpg',cv2.IMREAD_GRAYSCALE)
cv2.imshow('lena',image)
cv2.waitKey(0)

image.shape
rows,cols = image.shape
input_images.shape

input_image = np.array(image).reshape((rows,cols,1))
input_images = np.array([input_image])

output_images = model.predict(input_images)

output_image = output_images[0].reshape((rows,cols))
np.amax(output_image)
np.amin(output_image)

np.savetxt('lena-sobel.txt', output_image, fmt='%f')

output_image = abs(output_image);
output_image = cv2.normalize(output_image,None,0,255,cv2.NORM_MINMAX)
output_image = np.uint8(output_image)
cv2.imwrite('lena-sobel.jpg',output_image)

cv2.imshow('lena',output_image)
cv2.waitKey(0)
cv2.destroyWindow('lena')

#quit()
